public class Ville {
 private String nom;  
 private int nbHabitants;

/********* 3 constructeurs **********************
* 1 par dfaut cre une ville inconnue, 
* 2 initialise le nom de la ville
* 3 fait appel au constructeur prcdent pour initialiser le nom 
*   de la ville, avant de fixer le nbHabitants 
 */
public Ville() {
 nom="VILLE INCONNUE";
}
public Ville(String nomVille) {
 nom=nomVille.toUpperCase();
}
public Ville(String nomVille, int nombre) {
 this(nomVille);
 if (nombre<=0) erreur("nbHabitants doit tre positif !");
 else nbHabitants=nombre;
}
//******** qq mthodes d'accs aux variables prives **********************
public String getNom() {
 return nom;
}
public void setNom(String nomVille) {
 if (nom.equals("VILLE INCONNUE") ) nom=nomVille.toUpperCase();
 else erreur(" il est interdit de changer le nom de la ville !");
}
public boolean nbHabConnu() {
 return nbHabitants >0;
}
public int getNbHabitants() {
 if (!nbHabConnu()) erreur("nombre d'habitants inconnu ");
 return nbHabitants;
}
public void setNbHabitants(int nombre) {
 if (nombre<=0) erreur("nbHabitants doit tre positif !");
 else nbHabitants=nombre;
}
//*********** mthode pour dcrire un objet Ville *******************
public String presenteToi() {
 String ch="Ville( "+nom+", ";
 if (nbHabConnu()) ch+=nbHabitants+" ) ";
 else  ch+=" nombre d'habitants inconnu )";
 return ch;
}
/****** mthode prive de classe pour signaler les erreurs *******
*  la mthode exit(int status) de la classe java.lang.System, provoque la fin de l'excution 
* par la MVJ. Si l'entier status est non nul, cela indique par convention que cette sortie 
* de programme est anormale.
*/ 
private static void erreur(String message) {
System.out.println("--> erreur classe Ville : "+message);
System.exit(1);
}
}
